#ifndef COMMONFNC_H
#define COMMONFNC_H

class CCommonFnc {
public:
    // CONVERT HEXADECIMAL STRING LIKE '05 0C 0F ...' INTO BYTE ARRAY REPRESENTATION
    static int BYTE_ConvertFromHexStringToArray(CString hexaString, BYTE* pArray, DWORD* pbArrayLen);
    static int BYTE_ConvertFromHexStringToArray(CString hexaString, BYTE* pArray, USHORT* pbArrayLen);
    // CONVERT BYTE ARRAY INTO HEXADECIMAL STRING LIKE '05 0C 0F ...' 
    static int BYTE_ConvertFromArrayToHexString(BYTE* pArray, DWORD pbArrayLen, CString* pHexaString);
    // CONVERT BYTE ARRAY INTO STRING (SOME CHARACTERS MAY BE INVISIBLE) 
    static int BYTE_ConvertFromArrayToString(BYTE* pArray, DWORD pbArrayLen, CString* pString);

    // CONVERT STRING INTO HEXADECIMAL STRING LIKE '05 0C 0F ...' 
    static int String_ConvertFromStringToHex(CString string, CString* pHexString);
    // ..VICE VERSA
    static int String_ConvertFromHexToString(CString hexString, CString* pString);
    
    // SEPARETE HEXADECIMAL VALUES (2 CHARACTERS FOR EACH VALUE) BY GIVEN SEPARATOR 
    static int String_SeparateHexValues(CString* pHexString, CString separator);
    // INSERT GIVEN SEPARATOR AFTER EACH charsPerLine CHARACTER
    static int String_SeparateLines(CString* pString, int charsPerLine, CString separator = "\r\n");

    // VALIDATE HEXADECIMAL STRING FOR INCORRECT VALUES 
    static int Hex_ValidateHexString(CString* pHexString);

    // EXTRACT TIME SPAN (FILETIME FORMAT) FROM START AND END TIME VALUE IN SYSTEMTIME FORMAT 
    static int Time_GetTimeSpan(SYSTEMTIME* pStartTime, SYSTEMTIME* pEndTime, FILETIME* pFileTimeSpan);
    // ... IN SECONDS 
    static int Time_GetTimeSpanSec(SYSTEMTIME* pStartTime, SYSTEMTIME* pEndTime, float* pFloatTimeSpan);
};

#endif