#include "status.h"

const char* ErrorToString(int error) {
    switch (error) {
        case STAT_OK:                                   return "SUCCESS";   
        case STAT_NOT_IMPLEMENTED_YET:                  return "NOT_IMPLEMENTED_YET";
        case STAT_SESSION_NOT_OPEN:                     return "SESSION_NOT_OPEN";
        case STAT_NOT_ENOUGHT_MEMORY:                   return "NOT_ENOUGHT_MEMORY";
        case STAT_CHANNEL_SECURITY_NOT_ACHIEVED:        return "CHANNEL_SECURITY_NOT_ACHIEVED";
        case STAT_CHANNEL_DESTROY_FAIL:                 return "CHANNEL_DESTROY_FAIL";
        case STAT_CHANNEL_NOT_EXISTS:                   return "CHANNEL_NOT_EXISTS"; 
                                                        
            // ISO7816 ERRORS                           
        case SW_FILE_FULL:                              return "SW_FILE_FULL";
        case SW_UNKNOWN:  				                return "SW_UNKNOWN";
        case SW_CLA_NOT_SUPPORTED: 		                return "SW_CLA_NOT_SUPPORTED";
        case SW_INS_NOT_SUPPORTED: 		                return "SW_INS_NOT_SUPPORTED";
        case SW_CORRECT_LENGTH_00: 		                return "SW_CORRECT_LENGTH_00";
        case SW_WRONG_P1P2:   			                return "SW_WRONG_P1P2";
        case SW_INCORRECT_P1P2:			                return "SW_INCORRECT_P1P2";
        case SW_RECORD_NOT_FOUND: 		                return "SW_RECORD_NOT_FOUND";	
        case SW_FILE_NOT_FOUND: 		                return "SW_CLA_NOT_SUPPORTED";
        case SW_FUNC_NOT_SUPPORTED:		                return "SW_FUNC_NOT_SUPPORTED";
        case SW_WRONG_DATA:   			                return "SW_WRONG_DATA";
        case SW_APPLET_SELECT_FAILED: 	                return "SW_APPLET_SELECT_FAILED";
        case SW_COMMAND_NOT_ALLOWED: 	                return "SW_COMMAND_NOT_ALLOWED";
        case SW_CONDITIONS_NOT_SATISFIED:               return "SW_CONDITIONS_NOT_SATISFIED";
        case SW_DATA_INVALID: 			                return "SW_DATA_INVALID";
        case SW_FILE_INVALID: 			                return "SW_FILE_INVALID";
        case SW_SECURITY_STATUS_NOT_SATISFIED:          return "SW_SECURITY_STATUS_NOT_SATISFIED";
        case SW_WRONG_LENGTH:         			        return "SW_WRONG_LENGTH";
        case SW_BYTES_REMAINING_00:       		        return "SW_BYTES_REMAINING_00";
        case SW_NO_ERROR:             			        return "SW_NO_ERROR";
                                                        
            // MY OWN APPLET ERRORS                     
        case SW_PIN_BLOCKED:			                return "SW_PIN_BLOCKED";
        case SW_USAGE_UPDATE_FAIL:	                    return "SW_USAGE_UPDATE_FAIL";
        case SW_USAGE_NOT_ALLOWED:	                    return "SW_USAGE_NOT_ALLOWED";
                                                        
        default:                                        return "UNKNOWN";   
    }
}  

